#Some throw away code that shows getting unit info from a juju deployed unit
#via zookeeper

#Format of machine-agent.conf file:
#env JUJU_ZOOKEEPER="server-e6a4527a-fde5-4511-8d60-010ef4f97968:2181"

from kazoo.client import KazooClient
import yaml
import time

def get_state_server_host():
	host = 'localhost'
	with open('/etc/init/juju-machine-agent.conf') as f:
		for line in f:
			if 'JUJU_ZOOKEEPER' in line:
				host = line.split('=')[1]
	return host.replace('"','').strip()

def get_services(zk):
	data = zk.get("topology", watch=service_watcher)[0]
	y = yaml.load(data)
	services = y["services"]
	for serviceName, serviceData in services.iteritems():
		units = []
		for u in serviceData["units"]:
			units.append(u)
		yield serviceName, units

def service_watcher(*args, **kwargs):
	print args, kwargs

def get_service(zk, service):
	data = zk.get("services/%s" % service)[0]
	y = yaml.load(data)
	charmName = y["charm"]
	charmVersion = y["charm"].split("-")[-1]
	return charmName, charmVersion

def get_status(zk, unit):
	data = zk.get("units/%s" % unit)[0]
	y = yaml.load(data)
	status = ''
	address = ''
	for k,v in y.iteritems():
		#print k,v
		if k == "workflow_state":
			for a,b in v.iteritems():
				status = b
				continue
		if k == "private-address":
			address = v	
		
	return status, address

def list_units(zk):
	ls = []
	for service, units in get_services(zk):
		name, version =  get_service(zk, service)
		for unit in units:
			status, address = get_status(zk, unit)
			ls.append({"Charm": name, "Version": version, "Status": status, "Address": address})
	return ls	
if __name__ == '__main__':
	host = get_state_server_host()
	zk = KazooClient(hosts=host)
	zk.start()
	units = list_units(zk)
	for unit in units:
		print unit
	time.sleep(60)
	zk.stop()

